/**
 * Copyright 2009-2012, Descartes Research Group, SDQ, IPD, KIT
 */
package edu.kit.ipd.descartes.mm.adaptationpoints.impl;

import org.eclipse.emf.ecore.EAttribute;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EPackage;
import org.eclipse.emf.ecore.EReference;
import org.eclipse.emf.ecore.impl.EPackageImpl;

import edu.kit.ipd.descartes.core.CorePackage;
import edu.kit.ipd.descartes.mm.adaptationpoints.AdaptationPoint;
import edu.kit.ipd.descartes.mm.adaptationpoints.AdaptationPointDescriptions;
import edu.kit.ipd.descartes.mm.adaptationpoints.AdaptationpointsFactory;
import edu.kit.ipd.descartes.mm.adaptationpoints.AdaptationpointsPackage;
import edu.kit.ipd.descartes.mm.adaptationpoints.ModelEntityConfigurationRange;
import edu.kit.ipd.descartes.mm.adaptationpoints.ModelVariableConfigurationRange;
import edu.kit.ipd.descartes.mm.adaptationpoints.OclConstraint;
import edu.kit.ipd.descartes.mm.adaptationpoints.PropertyRange;
import edu.kit.ipd.descartes.mm.adaptationpoints.SetOfConfigurations;
import edu.kit.ipd.descartes.mm.adaptationpoints.VariationType;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model <b>Package</b>.
 * <!-- end-user-doc -->
 * @generated
 */
public class AdaptationpointsPackageImpl extends EPackageImpl implements AdaptationpointsPackage {
    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    private EClass adaptationPointDescriptionsEClass = null;

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    private EClass adaptationPointEClass = null;

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    private EClass modelVariableConfigurationRangeEClass = null;

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    private EClass modelEntityConfigurationRangeEClass = null;

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    private EClass variationTypeEClass = null;

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    private EClass propertyRangeEClass = null;

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    private EClass setOfConfigurationsEClass = null;

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    private EClass oclConstraintEClass = null;

    /**
     * Creates an instance of the model <b>Package</b>, registered with
     * {@link org.eclipse.emf.ecore.EPackage.Registry EPackage.Registry} by the package
     * package URI value.
     * <p>Note: the correct way to create the package is via the static
     * factory method {@link #init init()}, which also performs
     * initialization of the package, or returns the registered package,
     * if one already exists.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see org.eclipse.emf.ecore.EPackage.Registry
     * @see edu.kit.ipd.descartes.mm.adaptationpoints.AdaptationpointsPackage#eNS_URI
     * @see #init()
     * @generated
     */
    private AdaptationpointsPackageImpl() {
        super(eNS_URI, AdaptationpointsFactory.eINSTANCE);
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    private static boolean isInited = false;

    /**
     * Creates, registers, and initializes the <b>Package</b> for this model, and for any others upon which it depends.
     * 
     * <p>This method is used to initialize {@link AdaptationpointsPackage#eINSTANCE} when that field is accessed.
     * Clients should not invoke it directly. Instead, they should simply access that field to obtain the package.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see #eNS_URI
     * @see #createPackageContents()
     * @see #initializePackageContents()
     * @generated
     */
    public static AdaptationpointsPackage init() {
        if (isInited) return (AdaptationpointsPackage)EPackage.Registry.INSTANCE.getEPackage(AdaptationpointsPackage.eNS_URI);

        // Obtain or create and register package
        AdaptationpointsPackageImpl theAdaptationpointsPackage = (AdaptationpointsPackageImpl)(EPackage.Registry.INSTANCE.get(eNS_URI) instanceof AdaptationpointsPackageImpl ? EPackage.Registry.INSTANCE.get(eNS_URI) : new AdaptationpointsPackageImpl());

        isInited = true;

        // Initialize simple dependencies
        CorePackage.eINSTANCE.eClass();

        // Create package meta-data objects
        theAdaptationpointsPackage.createPackageContents();

        // Initialize created meta-data
        theAdaptationpointsPackage.initializePackageContents();

        // Mark meta-data to indicate it can't be changed
        theAdaptationpointsPackage.freeze();

  
        // Update the registry and return the package
        EPackage.Registry.INSTANCE.put(AdaptationpointsPackage.eNS_URI, theAdaptationpointsPackage);
        return theAdaptationpointsPackage;
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public EClass getAdaptationPointDescriptions() {
        return adaptationPointDescriptionsEClass;
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public EReference getAdaptationPointDescriptions_AdaptationPoints() {
        return (EReference)adaptationPointDescriptionsEClass.getEStructuralFeatures().get(0);
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public EClass getAdaptationPoint() {
        return adaptationPointEClass;
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public EClass getModelVariableConfigurationRange() {
        return modelVariableConfigurationRangeEClass;
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public EReference getModelVariableConfigurationRange_AdaptableEntity() {
        return (EReference)modelVariableConfigurationRangeEClass.getEStructuralFeatures().get(0);
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public EAttribute getModelVariableConfigurationRange_MinValue() {
        return (EAttribute)modelVariableConfigurationRangeEClass.getEStructuralFeatures().get(1);
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public EAttribute getModelVariableConfigurationRange_MaxValue() {
        return (EAttribute)modelVariableConfigurationRangeEClass.getEStructuralFeatures().get(2);
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public EClass getModelEntityConfigurationRange() {
        return modelEntityConfigurationRangeEClass;
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public EReference getModelEntityConfigurationRange_VariationPossibility() {
        return (EReference)modelEntityConfigurationRangeEClass.getEStructuralFeatures().get(0);
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public EReference getModelEntityConfigurationRange_AdaptableEntity() {
        return (EReference)modelEntityConfigurationRangeEClass.getEStructuralFeatures().get(1);
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public EClass getVariationType() {
        return variationTypeEClass;
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public EClass getPropertyRange() {
        return propertyRangeEClass;
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public EReference getPropertyRange_MinValueConstraint() {
        return (EReference)propertyRangeEClass.getEStructuralFeatures().get(0);
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public EReference getPropertyRange_MaxValueConstraint() {
        return (EReference)propertyRangeEClass.getEStructuralFeatures().get(1);
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public EClass getSetOfConfigurations() {
        return setOfConfigurationsEClass;
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public EReference getSetOfConfigurations_ValueConstraint() {
        return (EReference)setOfConfigurationsEClass.getEStructuralFeatures().get(0);
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public EReference getSetOfConfigurations_Variants() {
        return (EReference)setOfConfigurationsEClass.getEStructuralFeatures().get(1);
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public EClass getOclConstraint() {
        return oclConstraintEClass;
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public EAttribute getOclConstraint_OclString() {
        return (EAttribute)oclConstraintEClass.getEStructuralFeatures().get(0);
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public EAttribute getOclConstraint_Name() {
        return (EAttribute)oclConstraintEClass.getEStructuralFeatures().get(1);
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public AdaptationpointsFactory getAdaptationpointsFactory() {
        return (AdaptationpointsFactory)getEFactoryInstance();
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    private boolean isCreated = false;

    /**
     * Creates the meta-model objects for the package.  This method is
     * guarded to have no affect on any invocation but its first.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public void createPackageContents() {
        if (isCreated) return;
        isCreated = true;

        // Create classes and their features
        adaptationPointDescriptionsEClass = createEClass(ADAPTATION_POINT_DESCRIPTIONS);
        createEReference(adaptationPointDescriptionsEClass, ADAPTATION_POINT_DESCRIPTIONS__ADAPTATION_POINTS);

        adaptationPointEClass = createEClass(ADAPTATION_POINT);

        modelVariableConfigurationRangeEClass = createEClass(MODEL_VARIABLE_CONFIGURATION_RANGE);
        createEReference(modelVariableConfigurationRangeEClass, MODEL_VARIABLE_CONFIGURATION_RANGE__ADAPTABLE_ENTITY);
        createEAttribute(modelVariableConfigurationRangeEClass, MODEL_VARIABLE_CONFIGURATION_RANGE__MIN_VALUE);
        createEAttribute(modelVariableConfigurationRangeEClass, MODEL_VARIABLE_CONFIGURATION_RANGE__MAX_VALUE);

        modelEntityConfigurationRangeEClass = createEClass(MODEL_ENTITY_CONFIGURATION_RANGE);
        createEReference(modelEntityConfigurationRangeEClass, MODEL_ENTITY_CONFIGURATION_RANGE__VARIATION_POSSIBILITY);
        createEReference(modelEntityConfigurationRangeEClass, MODEL_ENTITY_CONFIGURATION_RANGE__ADAPTABLE_ENTITY);

        variationTypeEClass = createEClass(VARIATION_TYPE);

        propertyRangeEClass = createEClass(PROPERTY_RANGE);
        createEReference(propertyRangeEClass, PROPERTY_RANGE__MIN_VALUE_CONSTRAINT);
        createEReference(propertyRangeEClass, PROPERTY_RANGE__MAX_VALUE_CONSTRAINT);

        setOfConfigurationsEClass = createEClass(SET_OF_CONFIGURATIONS);
        createEReference(setOfConfigurationsEClass, SET_OF_CONFIGURATIONS__VALUE_CONSTRAINT);
        createEReference(setOfConfigurationsEClass, SET_OF_CONFIGURATIONS__VARIANTS);

        oclConstraintEClass = createEClass(OCL_CONSTRAINT);
        createEAttribute(oclConstraintEClass, OCL_CONSTRAINT__OCL_STRING);
        createEAttribute(oclConstraintEClass, OCL_CONSTRAINT__NAME);
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    private boolean isInitialized = false;

    /**
     * Complete the initialization of the package and its meta-model.  This
     * method is guarded to have no affect on any invocation but its first.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public void initializePackageContents() {
        if (isInitialized) return;
        isInitialized = true;

        // Initialize package
        setName(eNAME);
        setNsPrefix(eNS_PREFIX);
        setNsURI(eNS_URI);

        // Obtain other dependent packages
        CorePackage theCorePackage = (CorePackage)EPackage.Registry.INSTANCE.getEPackage(CorePackage.eNS_URI);

        // Create type parameters

        // Set bounds for type parameters

        // Add supertypes to classes
        adaptationPointDescriptionsEClass.getESuperTypes().add(theCorePackage.getEntity());
        adaptationPointEClass.getESuperTypes().add(theCorePackage.getEntity());
        modelVariableConfigurationRangeEClass.getESuperTypes().add(this.getAdaptationPoint());
        modelEntityConfigurationRangeEClass.getESuperTypes().add(this.getAdaptationPoint());
        propertyRangeEClass.getESuperTypes().add(this.getVariationType());
        setOfConfigurationsEClass.getESuperTypes().add(this.getVariationType());

        // Initialize classes and features; add operations and parameters
        initEClass(adaptationPointDescriptionsEClass, AdaptationPointDescriptions.class, "AdaptationPointDescriptions", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
        initEReference(getAdaptationPointDescriptions_AdaptationPoints(), this.getAdaptationPoint(), null, "adaptationPoints", null, 0, -1, AdaptationPointDescriptions.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

        initEClass(adaptationPointEClass, AdaptationPoint.class, "AdaptationPoint", IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);

        initEClass(modelVariableConfigurationRangeEClass, ModelVariableConfigurationRange.class, "ModelVariableConfigurationRange", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
        initEReference(getModelVariableConfigurationRange_AdaptableEntity(), theCorePackage.getAdaptableEntity(), null, "adaptableEntity", null, 1, 1, ModelVariableConfigurationRange.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
        initEAttribute(getModelVariableConfigurationRange_MinValue(), ecorePackage.getEDouble(), "minValue", null, 1, 1, ModelVariableConfigurationRange.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
        initEAttribute(getModelVariableConfigurationRange_MaxValue(), ecorePackage.getEDouble(), "maxValue", null, 1, 1, ModelVariableConfigurationRange.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

        initEClass(modelEntityConfigurationRangeEClass, ModelEntityConfigurationRange.class, "ModelEntityConfigurationRange", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
        initEReference(getModelEntityConfigurationRange_VariationPossibility(), this.getVariationType(), null, "variationPossibility", null, 1, 1, ModelEntityConfigurationRange.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
        initEReference(getModelEntityConfigurationRange_AdaptableEntity(), theCorePackage.getEntity(), null, "adaptableEntity", null, 1, 1, ModelEntityConfigurationRange.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

        initEClass(variationTypeEClass, VariationType.class, "VariationType", IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);

        initEClass(propertyRangeEClass, PropertyRange.class, "PropertyRange", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
        initEReference(getPropertyRange_MinValueConstraint(), this.getOclConstraint(), null, "minValueConstraint", null, 1, 1, PropertyRange.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
        initEReference(getPropertyRange_MaxValueConstraint(), this.getOclConstraint(), null, "maxValueConstraint", null, 1, 1, PropertyRange.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

        initEClass(setOfConfigurationsEClass, SetOfConfigurations.class, "SetOfConfigurations", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
        initEReference(getSetOfConfigurations_ValueConstraint(), this.getOclConstraint(), null, "valueConstraint", null, 1, 1, SetOfConfigurations.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
        initEReference(getSetOfConfigurations_Variants(), theCorePackage.getEntity(), null, "variants", null, 0, -1, SetOfConfigurations.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

        initEClass(oclConstraintEClass, OclConstraint.class, "OclConstraint", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
        initEAttribute(getOclConstraint_OclString(), ecorePackage.getEString(), "oclString", null, 1, 1, OclConstraint.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
        initEAttribute(getOclConstraint_Name(), ecorePackage.getEString(), "name", null, 1, 1, OclConstraint.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

        // Create resource
        createResource(eNS_URI);
    }

} //AdaptationpointsPackageImpl
