/**
 * Copyright 2009-2012, Descartes Research Group, SDQ, IPD, KIT
 */
package edu.kit.ipd.descartes.mm.applicationlevel.parameterdependencies.impl;

import edu.kit.ipd.descartes.mm.applicationlevel.parameterdependencies.DependencyRelationship;
import edu.kit.ipd.descartes.mm.applicationlevel.parameterdependencies.InfluencedVariableReference;
import edu.kit.ipd.descartes.mm.applicationlevel.parameterdependencies.InfluencingParameter;
import edu.kit.ipd.descartes.mm.applicationlevel.parameterdependencies.ParameterdependenciesPackage;

import java.util.Collection;

import org.eclipse.emf.common.notify.Notification;

import org.eclipse.emf.common.util.EList;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;

import org.eclipse.emf.ecore.impl.ENotificationImpl;

import org.eclipse.emf.ecore.util.EObjectResolvingEList;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Dependency Relationship</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 *   <li>{@link edu.kit.ipd.descartes.mm.applicationlevel.parameterdependencies.impl.DependencyRelationshipImpl#getDependent <em>Dependent</em>}</li>
 *   <li>{@link edu.kit.ipd.descartes.mm.applicationlevel.parameterdependencies.impl.DependencyRelationshipImpl#getIndependent <em>Independent</em>}</li>
 * </ul>
 * </p>
 *
 * @generated
 */
public class DependencyRelationshipImpl extends RelationshipImpl implements DependencyRelationship {
	/**
	 * The cached value of the '{@link #getDependent() <em>Dependent</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getDependent()
	 * @generated
	 * @ordered
	 */
	protected InfluencedVariableReference dependent;

	/**
	 * The cached value of the '{@link #getIndependent() <em>Independent</em>}' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getIndependent()
	 * @generated
	 * @ordered
	 */
	protected EList<InfluencingParameter> independent;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected DependencyRelationshipImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected EClass eStaticClass() {
		return ParameterdependenciesPackage.Literals.DEPENDENCY_RELATIONSHIP;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public InfluencedVariableReference getDependent() {
		if (dependent != null && dependent.eIsProxy()) {
			InternalEObject oldDependent = (InternalEObject)dependent;
			dependent = (InfluencedVariableReference)eResolveProxy(oldDependent);
			if (dependent != oldDependent) {
				if (eNotificationRequired())
					eNotify(new ENotificationImpl(this, Notification.RESOLVE, ParameterdependenciesPackage.DEPENDENCY_RELATIONSHIP__DEPENDENT, oldDependent, dependent));
			}
		}
		return dependent;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public InfluencedVariableReference basicGetDependent() {
		return dependent;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setDependent(InfluencedVariableReference newDependent) {
		InfluencedVariableReference oldDependent = dependent;
		dependent = newDependent;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, ParameterdependenciesPackage.DEPENDENCY_RELATIONSHIP__DEPENDENT, oldDependent, dependent));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList<InfluencingParameter> getIndependent() {
		if (independent == null) {
			independent = new EObjectResolvingEList<InfluencingParameter>(InfluencingParameter.class, this, ParameterdependenciesPackage.DEPENDENCY_RELATIONSHIP__INDEPENDENT);
		}
		return independent;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object eGet(int featureID, boolean resolve, boolean coreType) {
		switch (featureID) {
			case ParameterdependenciesPackage.DEPENDENCY_RELATIONSHIP__DEPENDENT:
				if (resolve) return getDependent();
				return basicGetDependent();
			case ParameterdependenciesPackage.DEPENDENCY_RELATIONSHIP__INDEPENDENT:
				return getIndependent();
		}
		return super.eGet(featureID, resolve, coreType);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@SuppressWarnings("unchecked")
	@Override
	public void eSet(int featureID, Object newValue) {
		switch (featureID) {
			case ParameterdependenciesPackage.DEPENDENCY_RELATIONSHIP__DEPENDENT:
				setDependent((InfluencedVariableReference)newValue);
				return;
			case ParameterdependenciesPackage.DEPENDENCY_RELATIONSHIP__INDEPENDENT:
				getIndependent().clear();
				getIndependent().addAll((Collection<? extends InfluencingParameter>)newValue);
				return;
		}
		super.eSet(featureID, newValue);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eUnset(int featureID) {
		switch (featureID) {
			case ParameterdependenciesPackage.DEPENDENCY_RELATIONSHIP__DEPENDENT:
				setDependent((InfluencedVariableReference)null);
				return;
			case ParameterdependenciesPackage.DEPENDENCY_RELATIONSHIP__INDEPENDENT:
				getIndependent().clear();
				return;
		}
		super.eUnset(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public boolean eIsSet(int featureID) {
		switch (featureID) {
			case ParameterdependenciesPackage.DEPENDENCY_RELATIONSHIP__DEPENDENT:
				return dependent != null;
			case ParameterdependenciesPackage.DEPENDENCY_RELATIONSHIP__INDEPENDENT:
				return independent != null && !independent.isEmpty();
		}
		return super.eIsSet(featureID);
	}

} //DependencyRelationshipImpl
