/**
 * Copyright 2009-2012, Descartes Research Group, SDQ, IPD, KIT
 */
package edu.kit.ipd.descartes.mm.applicationlevel.servicebehavior.impl;

import edu.kit.ipd.descartes.mm.applicationlevel.servicebehavior.ComponentInternalBehavior;
import edu.kit.ipd.descartes.mm.applicationlevel.servicebehavior.ForkAction;
import edu.kit.ipd.descartes.mm.applicationlevel.servicebehavior.ServicebehaviorPackage;

import java.util.Collection;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;

import org.eclipse.emf.common.util.EList;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;

import org.eclipse.emf.ecore.impl.ENotificationImpl;

import org.eclipse.emf.ecore.util.EObjectContainmentEList;
import org.eclipse.emf.ecore.util.InternalEList;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Fork Action</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 *   <li>{@link edu.kit.ipd.descartes.mm.applicationlevel.servicebehavior.impl.ForkActionImpl#isWithSynchronizationBarrier <em>With Synchronization Barrier</em>}</li>
 *   <li>{@link edu.kit.ipd.descartes.mm.applicationlevel.servicebehavior.impl.ForkActionImpl#getForkedBehaviors <em>Forked Behaviors</em>}</li>
 * </ul>
 * </p>
 *
 * @generated
 */
public class ForkActionImpl extends AbstractActionImpl implements ForkAction {
	/**
	 * The default value of the '{@link #isWithSynchronizationBarrier() <em>With Synchronization Barrier</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #isWithSynchronizationBarrier()
	 * @generated
	 * @ordered
	 */
	protected static final boolean WITH_SYNCHRONIZATION_BARRIER_EDEFAULT = false;

	/**
	 * The cached value of the '{@link #isWithSynchronizationBarrier() <em>With Synchronization Barrier</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #isWithSynchronizationBarrier()
	 * @generated
	 * @ordered
	 */
	protected boolean withSynchronizationBarrier = WITH_SYNCHRONIZATION_BARRIER_EDEFAULT;

	/**
	 * The cached value of the '{@link #getForkedBehaviors() <em>Forked Behaviors</em>}' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getForkedBehaviors()
	 * @generated
	 * @ordered
	 */
	protected EList<ComponentInternalBehavior> forkedBehaviors;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected ForkActionImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected EClass eStaticClass() {
		return ServicebehaviorPackage.Literals.FORK_ACTION;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public boolean isWithSynchronizationBarrier() {
		return withSynchronizationBarrier;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setWithSynchronizationBarrier(boolean newWithSynchronizationBarrier) {
		boolean oldWithSynchronizationBarrier = withSynchronizationBarrier;
		withSynchronizationBarrier = newWithSynchronizationBarrier;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, ServicebehaviorPackage.FORK_ACTION__WITH_SYNCHRONIZATION_BARRIER, oldWithSynchronizationBarrier, withSynchronizationBarrier));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList<ComponentInternalBehavior> getForkedBehaviors() {
		if (forkedBehaviors == null) {
			forkedBehaviors = new EObjectContainmentEList<ComponentInternalBehavior>(ComponentInternalBehavior.class, this, ServicebehaviorPackage.FORK_ACTION__FORKED_BEHAVIORS);
		}
		return forkedBehaviors;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, NotificationChain msgs) {
		switch (featureID) {
			case ServicebehaviorPackage.FORK_ACTION__FORKED_BEHAVIORS:
				return ((InternalEList<?>)getForkedBehaviors()).basicRemove(otherEnd, msgs);
		}
		return super.eInverseRemove(otherEnd, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object eGet(int featureID, boolean resolve, boolean coreType) {
		switch (featureID) {
			case ServicebehaviorPackage.FORK_ACTION__WITH_SYNCHRONIZATION_BARRIER:
				return isWithSynchronizationBarrier();
			case ServicebehaviorPackage.FORK_ACTION__FORKED_BEHAVIORS:
				return getForkedBehaviors();
		}
		return super.eGet(featureID, resolve, coreType);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@SuppressWarnings("unchecked")
	@Override
	public void eSet(int featureID, Object newValue) {
		switch (featureID) {
			case ServicebehaviorPackage.FORK_ACTION__WITH_SYNCHRONIZATION_BARRIER:
				setWithSynchronizationBarrier((Boolean)newValue);
				return;
			case ServicebehaviorPackage.FORK_ACTION__FORKED_BEHAVIORS:
				getForkedBehaviors().clear();
				getForkedBehaviors().addAll((Collection<? extends ComponentInternalBehavior>)newValue);
				return;
		}
		super.eSet(featureID, newValue);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eUnset(int featureID) {
		switch (featureID) {
			case ServicebehaviorPackage.FORK_ACTION__WITH_SYNCHRONIZATION_BARRIER:
				setWithSynchronizationBarrier(WITH_SYNCHRONIZATION_BARRIER_EDEFAULT);
				return;
			case ServicebehaviorPackage.FORK_ACTION__FORKED_BEHAVIORS:
				getForkedBehaviors().clear();
				return;
		}
		super.eUnset(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public boolean eIsSet(int featureID) {
		switch (featureID) {
			case ServicebehaviorPackage.FORK_ACTION__WITH_SYNCHRONIZATION_BARRIER:
				return withSynchronizationBarrier != WITH_SYNCHRONIZATION_BARRIER_EDEFAULT;
			case ServicebehaviorPackage.FORK_ACTION__FORKED_BEHAVIORS:
				return forkedBehaviors != null && !forkedBehaviors.isEmpty();
		}
		return super.eIsSet(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public String toString() {
		if (eIsProxy()) return super.toString();

		StringBuffer result = new StringBuffer(super.toString());
		result.append(" (withSynchronizationBarrier: ");
		result.append(withSynchronizationBarrier);
		result.append(')');
		return result.toString();
	}

} //ForkActionImpl
