/**
 * Copyright 2009-2012, Descartes Research Group, SDQ, IPD, KIT
 */
package edu.kit.ipd.descartes.mm.applicationlevel.servicebehavior.impl;

import edu.kit.ipd.descartes.mm.applicationlevel.functions.RandomVariable;
import edu.kit.ipd.descartes.mm.applicationlevel.parameterdependencies.ModelVariableCharacterizationType;
import edu.kit.ipd.descartes.mm.applicationlevel.parameterdependencies.impl.ModelVariableImpl;
import edu.kit.ipd.descartes.mm.applicationlevel.servicebehavior.BlackBoxBehavior;
import edu.kit.ipd.descartes.mm.applicationlevel.servicebehavior.ResponseTime;
import edu.kit.ipd.descartes.mm.applicationlevel.servicebehavior.ServicebehaviorPackage;
import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;
import org.eclipse.emf.ecore.impl.ENotificationImpl;
import org.eclipse.emf.ecore.util.EcoreUtil;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Response Time</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 *   <li>{@link edu.kit.ipd.descartes.mm.applicationlevel.servicebehavior.impl.ResponseTimeImpl#getBlackBoxBehavior <em>Black Box Behavior</em>}</li>
 *   <li>{@link edu.kit.ipd.descartes.mm.applicationlevel.servicebehavior.impl.ResponseTimeImpl#getCharacterization <em>Characterization</em>}</li>
 *   <li>{@link edu.kit.ipd.descartes.mm.applicationlevel.servicebehavior.impl.ResponseTimeImpl#getExplicitDescription <em>Explicit Description</em>}</li>
 * </ul>
 * </p>
 *
 * @generated
 */
public class ResponseTimeImpl extends ModelVariableImpl implements ResponseTime {
	/**
	 * The default value of the '{@link #getCharacterization() <em>Characterization</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getCharacterization()
	 * @generated
	 * @ordered
	 */
	protected static final ModelVariableCharacterizationType CHARACTERIZATION_EDEFAULT = ModelVariableCharacterizationType.EMPIRICAL;

	/**
	 * The cached value of the '{@link #getCharacterization() <em>Characterization</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getCharacterization()
	 * @generated
	 * @ordered
	 */
	protected ModelVariableCharacterizationType characterization = CHARACTERIZATION_EDEFAULT;

	/**
	 * The cached value of the '{@link #getExplicitDescription() <em>Explicit Description</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getExplicitDescription()
	 * @generated
	 * @ordered
	 */
	protected RandomVariable explicitDescription;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected ResponseTimeImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected EClass eStaticClass() {
		return ServicebehaviorPackage.Literals.RESPONSE_TIME;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public BlackBoxBehavior getBlackBoxBehavior() {
		if (eContainerFeatureID() != ServicebehaviorPackage.RESPONSE_TIME__BLACK_BOX_BEHAVIOR) return null;
		return (BlackBoxBehavior)eInternalContainer();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain basicSetBlackBoxBehavior(BlackBoxBehavior newBlackBoxBehavior, NotificationChain msgs) {
		msgs = eBasicSetContainer((InternalEObject)newBlackBoxBehavior, ServicebehaviorPackage.RESPONSE_TIME__BLACK_BOX_BEHAVIOR, msgs);
		return msgs;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void setBlackBoxBehavior(BlackBoxBehavior newBlackBoxBehavior) {
		if (newBlackBoxBehavior != eInternalContainer() || (eContainerFeatureID() != ServicebehaviorPackage.RESPONSE_TIME__BLACK_BOX_BEHAVIOR && newBlackBoxBehavior != null)) {
			if (EcoreUtil.isAncestor(this, newBlackBoxBehavior))
				throw new IllegalArgumentException("Recursive containment not allowed for " + toString());
			NotificationChain msgs = null;
			if (eInternalContainer() != null)
				msgs = eBasicRemoveFromContainer(msgs);
			if (newBlackBoxBehavior != null)
				msgs = ((InternalEObject)newBlackBoxBehavior).eInverseAdd(this, ServicebehaviorPackage.BLACK_BOX_BEHAVIOR__RESPONSE_TIME, BlackBoxBehavior.class, msgs);
			msgs = basicSetBlackBoxBehavior(newBlackBoxBehavior, msgs);
			if (msgs != null) msgs.dispatch();
		}
		else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, ServicebehaviorPackage.RESPONSE_TIME__BLACK_BOX_BEHAVIOR, newBlackBoxBehavior, newBlackBoxBehavior));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public ModelVariableCharacterizationType getCharacterization() {
		return characterization;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void setCharacterization(ModelVariableCharacterizationType newCharacterization) {
		ModelVariableCharacterizationType oldCharacterization = characterization;
		characterization = newCharacterization == null ? CHARACTERIZATION_EDEFAULT : newCharacterization;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, ServicebehaviorPackage.RESPONSE_TIME__CHARACTERIZATION, oldCharacterization, characterization));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public RandomVariable getExplicitDescription() {
		return explicitDescription;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain basicSetExplicitDescription(RandomVariable newExplicitDescription, NotificationChain msgs) {
		RandomVariable oldExplicitDescription = explicitDescription;
		explicitDescription = newExplicitDescription;
		if (eNotificationRequired()) {
			ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, ServicebehaviorPackage.RESPONSE_TIME__EXPLICIT_DESCRIPTION, oldExplicitDescription, newExplicitDescription);
			if (msgs == null) msgs = notification; else msgs.add(notification);
		}
		return msgs;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void setExplicitDescription(RandomVariable newExplicitDescription) {
		if (newExplicitDescription != explicitDescription) {
			NotificationChain msgs = null;
			if (explicitDescription != null)
				msgs = ((InternalEObject)explicitDescription).eInverseRemove(this, EOPPOSITE_FEATURE_BASE - ServicebehaviorPackage.RESPONSE_TIME__EXPLICIT_DESCRIPTION, null, msgs);
			if (newExplicitDescription != null)
				msgs = ((InternalEObject)newExplicitDescription).eInverseAdd(this, EOPPOSITE_FEATURE_BASE - ServicebehaviorPackage.RESPONSE_TIME__EXPLICIT_DESCRIPTION, null, msgs);
			msgs = basicSetExplicitDescription(newExplicitDescription, msgs);
			if (msgs != null) msgs.dispatch();
		}
		else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, ServicebehaviorPackage.RESPONSE_TIME__EXPLICIT_DESCRIPTION, newExplicitDescription, newExplicitDescription));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public NotificationChain eInverseAdd(InternalEObject otherEnd, int featureID, NotificationChain msgs) {
		switch (featureID) {
			case ServicebehaviorPackage.RESPONSE_TIME__BLACK_BOX_BEHAVIOR:
				if (eInternalContainer() != null)
					msgs = eBasicRemoveFromContainer(msgs);
				return basicSetBlackBoxBehavior((BlackBoxBehavior)otherEnd, msgs);
		}
		return super.eInverseAdd(otherEnd, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, NotificationChain msgs) {
		switch (featureID) {
			case ServicebehaviorPackage.RESPONSE_TIME__BLACK_BOX_BEHAVIOR:
				return basicSetBlackBoxBehavior(null, msgs);
			case ServicebehaviorPackage.RESPONSE_TIME__EXPLICIT_DESCRIPTION:
				return basicSetExplicitDescription(null, msgs);
		}
		return super.eInverseRemove(otherEnd, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public NotificationChain eBasicRemoveFromContainerFeature(NotificationChain msgs) {
		switch (eContainerFeatureID()) {
			case ServicebehaviorPackage.RESPONSE_TIME__BLACK_BOX_BEHAVIOR:
				return eInternalContainer().eInverseRemove(this, ServicebehaviorPackage.BLACK_BOX_BEHAVIOR__RESPONSE_TIME, BlackBoxBehavior.class, msgs);
		}
		return super.eBasicRemoveFromContainerFeature(msgs);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object eGet(int featureID, boolean resolve, boolean coreType) {
		switch (featureID) {
			case ServicebehaviorPackage.RESPONSE_TIME__BLACK_BOX_BEHAVIOR:
				return getBlackBoxBehavior();
			case ServicebehaviorPackage.RESPONSE_TIME__CHARACTERIZATION:
				return getCharacterization();
			case ServicebehaviorPackage.RESPONSE_TIME__EXPLICIT_DESCRIPTION:
				return getExplicitDescription();
		}
		return super.eGet(featureID, resolve, coreType);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eSet(int featureID, Object newValue) {
		switch (featureID) {
			case ServicebehaviorPackage.RESPONSE_TIME__BLACK_BOX_BEHAVIOR:
				setBlackBoxBehavior((BlackBoxBehavior)newValue);
				return;
			case ServicebehaviorPackage.RESPONSE_TIME__CHARACTERIZATION:
				setCharacterization((ModelVariableCharacterizationType)newValue);
				return;
			case ServicebehaviorPackage.RESPONSE_TIME__EXPLICIT_DESCRIPTION:
				setExplicitDescription((RandomVariable)newValue);
				return;
		}
		super.eSet(featureID, newValue);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eUnset(int featureID) {
		switch (featureID) {
			case ServicebehaviorPackage.RESPONSE_TIME__BLACK_BOX_BEHAVIOR:
				setBlackBoxBehavior((BlackBoxBehavior)null);
				return;
			case ServicebehaviorPackage.RESPONSE_TIME__CHARACTERIZATION:
				setCharacterization(CHARACTERIZATION_EDEFAULT);
				return;
			case ServicebehaviorPackage.RESPONSE_TIME__EXPLICIT_DESCRIPTION:
				setExplicitDescription((RandomVariable)null);
				return;
		}
		super.eUnset(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public boolean eIsSet(int featureID) {
		switch (featureID) {
			case ServicebehaviorPackage.RESPONSE_TIME__BLACK_BOX_BEHAVIOR:
				return getBlackBoxBehavior() != null;
			case ServicebehaviorPackage.RESPONSE_TIME__CHARACTERIZATION:
				return characterization != CHARACTERIZATION_EDEFAULT;
			case ServicebehaviorPackage.RESPONSE_TIME__EXPLICIT_DESCRIPTION:
				return explicitDescription != null;
		}
		return super.eIsSet(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public String toString() {
		if (eIsProxy()) return super.toString();

		StringBuffer result = new StringBuffer(super.toString());
		result.append(" (characterization: ");
		result.append(characterization);
		result.append(')');
		return result.toString();
	}

} //ResponseTimeImpl
