/**
 * Copyright 2009-2012, Descartes Research Group, SDQ, IPD, KIT
 */
package edu.kit.ipd.descartes.mm.containerrepository;

import edu.kit.ipd.descartes.core.Entity;

import edu.kit.ipd.descartes.mm.resourceconfiguration.ConfigurationSpecification;

import edu.kit.ipd.descartes.mm.resourcelandscape.Container;

import org.eclipse.emf.common.util.EList;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Container Template</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link edu.kit.ipd.descartes.mm.containerrepository.ContainerTemplate#getTemplateConfig <em>Template Config</em>}</li>
 *   <li>{@link edu.kit.ipd.descartes.mm.containerrepository.ContainerTemplate#getReferringContainers <em>Referring Containers</em>}</li>
 *   <li>{@link edu.kit.ipd.descartes.mm.containerrepository.ContainerTemplate#getRunningOn <em>Running On</em>}</li>
 * </ul>
 * </p>
 *
 * @see edu.kit.ipd.descartes.mm.containerrepository.ContainerrepositoryPackage#getContainerTemplate()
 * @model
 * @generated
 */
public interface ContainerTemplate extends Entity {
	/**
     * Returns the value of the '<em><b>Template Config</b></em>' containment reference list.
     * The list contents are of type {@link edu.kit.ipd.descartes.mm.resourceconfiguration.ConfigurationSpecification}.
     * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Template Config</em>' containment reference list isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
     * @return the value of the '<em>Template Config</em>' containment reference list.
     * @see edu.kit.ipd.descartes.mm.containerrepository.ContainerrepositoryPackage#getContainerTemplate_TemplateConfig()
     * @model containment="true"
     * @generated
     */
	EList<ConfigurationSpecification> getTemplateConfig();

	/**
     * Returns the value of the '<em><b>Referring Containers</b></em>' reference list.
     * The list contents are of type {@link edu.kit.ipd.descartes.mm.resourcelandscape.Container}.
     * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Referring Containers</em>' reference list isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
     * @return the value of the '<em>Referring Containers</em>' reference list.
     * @see edu.kit.ipd.descartes.mm.containerrepository.ContainerrepositoryPackage#getContainerTemplate_ReferringContainers()
     * @model
     * @generated
     */
	EList<Container> getReferringContainers();

    /**
     * Returns the value of the '<em><b>Running On</b></em>' reference list.
     * The list contents are of type {@link edu.kit.ipd.descartes.mm.resourcelandscape.Container}.
     * <!-- begin-user-doc -->
     * <p>
     * If the meaning of the '<em>Running On</em>' reference list isn't clear,
     * there really should be more of a description here...
     * </p>
     * <!-- end-user-doc -->
     * @return the value of the '<em>Running On</em>' reference list.
     * @see edu.kit.ipd.descartes.mm.containerrepository.ContainerrepositoryPackage#getContainerTemplate_RunningOn()
     * @model
     * @generated
     */
    EList<Container> getRunningOn();

} // ContainerTemplate
