/**
 * Copyright 2009-2012, Descartes Research Group, SDQ, IPD, KIT
 */
package edu.kit.ipd.descartes.mm.usageprofile;

import edu.kit.ipd.descartes.core.Entity;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Usage Scenario</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link edu.kit.ipd.descartes.mm.usageprofile.UsageScenario#getUsageModel <em>Usage Model</em>}</li>
 *   <li>{@link edu.kit.ipd.descartes.mm.usageprofile.UsageScenario#getScenarioBehavior <em>Scenario Behavior</em>}</li>
 *   <li>{@link edu.kit.ipd.descartes.mm.usageprofile.UsageScenario#getWorkloadType <em>Workload Type</em>}</li>
 * </ul>
 * </p>
 *
 * @see edu.kit.ipd.descartes.mm.usageprofile.UsageProfilePackage#getUsageScenario()
 * @model
 * @generated
 */
public interface UsageScenario extends Entity {
	/**
	 * Returns the value of the '<em><b>Usage Model</b></em>' container reference.
	 * It is bidirectional and its opposite is '{@link edu.kit.ipd.descartes.mm.usageprofile.UsageProfile#getUsageScenarios <em>Usage Scenarios</em>}'.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Usage Model</em>' container reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Usage Model</em>' container reference.
	 * @see #setUsageModel(UsageProfile)
	 * @see edu.kit.ipd.descartes.mm.usageprofile.UsageProfilePackage#getUsageScenario_UsageModel()
	 * @see edu.kit.ipd.descartes.mm.usageprofile.UsageProfile#getUsageScenarios
	 * @model opposite="usageScenarios" required="true" transient="false"
	 * @generated
	 */
	UsageProfile getUsageModel();

	/**
	 * Sets the value of the '{@link edu.kit.ipd.descartes.mm.usageprofile.UsageScenario#getUsageModel <em>Usage Model</em>}' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Usage Model</em>' container reference.
	 * @see #getUsageModel()
	 * @generated
	 */
	void setUsageModel(UsageProfile value);

	/**
	 * Returns the value of the '<em><b>Scenario Behavior</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Scenario Behavior</em>' containment reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Scenario Behavior</em>' containment reference.
	 * @see #setScenarioBehavior(ScenarioBehavior)
	 * @see edu.kit.ipd.descartes.mm.usageprofile.UsageProfilePackage#getUsageScenario_ScenarioBehavior()
	 * @model containment="true" required="true"
	 * @generated
	 */
	ScenarioBehavior getScenarioBehavior();

	/**
	 * Sets the value of the '{@link edu.kit.ipd.descartes.mm.usageprofile.UsageScenario#getScenarioBehavior <em>Scenario Behavior</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Scenario Behavior</em>' containment reference.
	 * @see #getScenarioBehavior()
	 * @generated
	 */
	void setScenarioBehavior(ScenarioBehavior value);

	/**
	 * Returns the value of the '<em><b>Workload Type</b></em>' containment reference.
	 * It is bidirectional and its opposite is '{@link edu.kit.ipd.descartes.mm.usageprofile.WorkloadType#getUsageScenario <em>Usage Scenario</em>}'.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Workload Type</em>' containment reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Workload Type</em>' containment reference.
	 * @see #setWorkloadType(WorkloadType)
	 * @see edu.kit.ipd.descartes.mm.usageprofile.UsageProfilePackage#getUsageScenario_WorkloadType()
	 * @see edu.kit.ipd.descartes.mm.usageprofile.WorkloadType#getUsageScenario
	 * @model opposite="usageScenario" containment="true" required="true"
	 * @generated
	 */
	WorkloadType getWorkloadType();

	/**
	 * Sets the value of the '{@link edu.kit.ipd.descartes.mm.usageprofile.UsageScenario#getWorkloadType <em>Workload Type</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Workload Type</em>' containment reference.
	 * @see #getWorkloadType()
	 * @generated
	 */
	void setWorkloadType(WorkloadType value);

} // UsageScenario
